typedef unsigned long UINT;
#define	INT_BITS ((sizeof(UINT)) * 8)

UINT SquareRoot(UINT arg)
{
	UINT trial;
	UINT root;

	trial = (UINT)1 << (INT_BITS - 1); // set up 100000... binary
	root = 0;				// Inside loop, really root * 2

	do 
	{
		trial >>= 1;		// move trial to next position within root
		root |= trial;		// combine trial bit into root

		if (arg < root)		// does trial root bit fit?
			root ^= trial;	// no, remove trial bit
		else
		{
			arg -= root;	// root fits, remove it from arg
			root += trial;	// double the trial bit
		}

		root >>= 1;			// move both root & trial to next
		trial >>= 1;		//	  position within arg

	} while (trial != 0);

	// Compute rounding
    // See if next bit computed would be 1; round up if so.
	if (arg > root)
		root++;

	return root;
}
